import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Thurallor.Common.Utils.Utils";

local hello = L:GetText("/HelloMessage");
hello = string.gsub(hello, "<version>", plugin:GetVersion());
Puts(hello);
--[[

tmp = Turbine.UI.Window();
tmp:SetVisible(true);
tmp:SetBackColor(Turbine.UI.Color.White);
function tmp:MouseClick()
    self:SetWantsUpdates(true);
    self.updateCount = 0;
end
function tmp:Update()
    self.updateCount = self.updateCount + 1;
    if (self.updateCount == 10) then
--        self.target = self.player:GetTarget();
        Puts("target is " .. self.target:GetName());
    elseif (self.updateCount >= 15 and self.updateCount <= 19) then
        local effects = self.target:GetEffects();
        Puts("effects size = " .. effects:GetCount());
AddCallback(effects, "EffectAdded", function() Puts("EffectAdded"); end);
    elseif (self.updateCount >= 20) then
        self:SetWantsUpdates(false);
    end
end
tmp.player = Turbine.Gameplay.LocalPlayer:GetInstance();
AddCallback(tmp.player, "TargetChanged", function()
    tmp.target = tmp.player:GetTarget();
    tmp:SetWantsUpdates(true);
    tmp.updateCount = 15;
end);
]]

win = Turbine.UI.Window();
--win:SetSize(480, 480);
win:SetBackground("Thurallor/MouseFinder/mouse_finder.tga");
win:SetVisible(true);
win:SetStretchMode(2);
win.nativeWidth, win.nativeHeight = win:GetSize();
win:SetVisible(false);
win:SetBackColorBlendMode(Turbine.UI.BlendMode.Color);
win:SetMouseVisible(false);
win:SetZOrder(2147483647);
win.backColor = Thurallor.Utils.Color(1, 1, 1);
win.rotateAngle = 0;
win.hueAngle = 0;

player = Turbine.Gameplay.LocalPlayer:GetInstance();
AddCallback(player, "InCombatChanged", function(sender, args)
    win.inCombat = player:IsInCombat();
    if (win.inCombat) then
        win.x, win.y = Turbine.UI.Display:GetMousePosition();
        win:SetWantsUpdates(true);
    end
end);

AddCallback(optionsPanel, "SettingsChanged", function()
    win:SetWantsUpdates(true);
    win.backColor = Thurallor.Utils.Color(settings.color.A, settings.color.R, settings.color.G, settings.color.B);
    if (not settings.cycleColors) then
        win:SetBackColor(win.backColor);
    end
    win.width, win.height = settings.scale * win.nativeWidth, settings.scale * win.nativeHeight;
    win:SetVisible(false);
    win.displayStartTime = nil;
    win.x, win.y = nil, nil;
    win:SetWantsUpdates(true);
end);

function win:Update()
    local x, y = Turbine.UI.Display:GetMousePosition();
    self.moved = ((self.x ~= x) or (self.y ~= y));
    self.x, self.y = x, y;
    if (self.moved) then
        if (not self.displayStartTime) then
            self:SetVisible(true);
            win:SetStretchMode(1);
            win:SetSize(win.width, win.height);
        end
        self:SetPosition(x - self.width / 2, y - self.height / 2);
        self.displayStartTime = Turbine.Engine.GetGameTime();
    elseif (self.displayStartTime) then
        if (Turbine.Engine.GetGameTime() - self.displayStartTime >= settings.persistTime) then
            self.displayStartTime = nil;
            self:SetVisible(false);
            if (settings.showOnlyInCombat and not self.inCombat) then
                self:SetWantsUpdates(false);
            end
        end
    end
    if (self.displayStartTime) then
        if (settings.speed > 0) then
            self.rotateAngle = self.rotateAngle + settings.speed;
            self:SetRotation({x = 0; y = 0; z = self.rotateAngle});
        end
        if (settings.cycleColors) then
            self.hueAngle = self.hueAngle + settings.colorCycleSpeed;
            self.backColor:SetHSV((self.hueAngle % 360) / 360, 1, 1);
            self:SetBackColor(self.backColor);
        end
    end
end
